--- old/usr/src/uts/common/fs/zfs/dsl_dataset.c	2015-10-16 11:29:50.121610035 +0200
+++ new/usr/src/uts/common/fs/zfs/dsl_dataset.c	2015-10-16 11:29:50.125466407 +0200
@@ -668,9 +668,15 @@
 			 */
 			if (!MUTEX_HELD(&ds->ds_lock)) {
 				mutex_enter(&ds->ds_lock);
+				VERIFY3U(strlen(name) +
+					 strlen(ds->ds_snapname) + 1, <=,
+					 ZFS_MAXNAMELEN);
 				(void) strcat(name, ds->ds_snapname);
 				mutex_exit(&ds->ds_lock);
 			} else {
+				VERIFY3U(strlen(name) +
+					 strlen(ds->ds_snapname) + 1, <=,
+					 ZFS_MAXNAMELEN);
 				(void) strcat(name, ds->ds_snapname);
 			}
 		}
